from Products.ERP5Type.Log import log

operation = None
parameter_dict = {}

for analysis_line in context.objectValues(portal_type="Data Analysis Line"):
  resource = analysis_line.getResourceValue()
  if resource is not None:
    resource_portal_type = resource.getPortalType()
  else:
    resource_portal_type = ''
  if resource_portal_type == 'Data Operation':
    log("Getting Data Operation and Resources from Data Analysis...")
    operation_analysis_line = analysis_line
    operation = analysis_line.getResourceValue()
  else:
    reference = analysis_line.getReference()
    aggregate = analysis_line.getAggregateDataStreamValue() or \
                analysis_line.getAggregateDataArrayValue() or \
                analysis_line.getAggregateDataDescriptorValue()
    parameter_dict[reference] = aggregate

script_id = operation.getScriptId()
log("Calling script: " + str(script_id))
getattr(operation_analysis_line, script_id)(**parameter_dict)
context.stop()
